// pages/advance.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    displayPop:false,
    popUI: {
        img: "",
        title: "",
        placeholder: "",
        text: "",
        boolType:false
    },
    editBody: {
        type: 0,
        param:{}
    },
    eventViewHeight:0,
    eventList:[],
    tags:[],
    channels:[],
    userData:{}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.setNavigationBarTitle({
        title: '高级功能',
    })
    this.loadData() 
  }, 
  loadData() {
    let joperate = app.globalData.joperate
    //设置公共属性
    joperate.setEventCommonAttr({"key1":"value1", "key2":"value2"})
    joperate.setEventDynamicAttr(()=>{
        return {"key2":"value3", "key3":"value4"}
    })
    app.globalData.joperate.userData((code,data)=>{
      if(!code) {
        this.setData({
            userData:data
        })
        this.loadUI()
      }
    })
    
  }, 
  loadUI() {
    var eventRow = 0 
    let eventList = [] 
    if(this.data.userData.events.length) {
        eventRow = parseInt(1 + (this.data.userData.events.length - 1) / 2);
        var tmpList = []
        this.data.userData.events.forEach(element => {
          tmpList.push(element)
          if (tmpList.length == 2){
            eventList.push(tmpList);
            tmpList = []
          }
        });
        if (tmpList.length) {
          eventList.push(tmpList);
        }
    }

    let channels = []
    if(this.data.userData.channels) { 
        for (const channel of this.data.userData.channels) {
            var imgName = ""
            if (channel.type == "WECHATOA") {
                imgName = "微信公众号@3x.png"
            } else if (channel.type == "WECHATTMP") {
                imgName = "微信小程序@3x.png"
            } else if (channel.type == "PUSH") {
                imgName = "app通知@3x.png"
            } else if (channel.type == "EMAIL") {
                imgName = "邮件@3x.png"
            } else if (channel.type == "SMS") {
                imgName = "短信@3x.png"
            } else if (channel.type == "DINGTALK") {
                imgName = "钉钉@3x.png"
            } else if (channel.type == "ALIPAYLIFE") {
                imgName = "支付宝@3x.png"
            }

            let contacts = channel.contactValues
            for (const key in contacts) {
                if (Object.hasOwnProperty.call(contacts, key)) {
                    const channelvalue = contacts[key];
                    var able = 0
                    if (channel.type != "PUSH" || channelvalue.length < 1) {
                        able = 1
                    }
                    channels.push({
                        channelname: channel.channelname + ' - ' + key,
                        imgName: imgName,
                        channelid: channel.channelid,
                        channelkey: key,
                        channelvalue: channelvalue ? channelvalue : "",
                        able: able 
                    })
                }
            }

        }
    }

    let users = []
    if(this.data.userData.user) { 
        for (const u of this.data.userData.user) {
            var value = ""
            if (u.value instanceof Array) {
                value = u.value.join(',')
            } else {
                if (u.datatype == 'datetime') {
                    value = this.timeintervalToStr(u.value)
                } else if (u.datatype == 'number') {
                    if (u.value) {
                        value = u.value + ""
                    } else {
                        value = "0"
                    }
                } else if (u.datatype == 'bool') {
                    if (u.value) {
                        value = u.value == "0" ? "FALSE" : "TRUE";
                    } else {
                        value = "FALSE"
                    }
                } else {
                    if (u.value) {
                        value = u.value
                    }
                }
            }
            
            var able = false
            if (u.type !=3 || value.length < 1) {
                able = true
            }
            users.push({
                displayName: u.displayName,
                value:value,
                able: able
            })
        }
    }

    let tags = []
    if(this.data.userData.tag) { 
        for (const t of this.data.userData.tag) {
            var value = t.identityValues.join(',')
            tags.push({
                displayName: t.displayName,
                identityValues:value,
            })
        }
    }  
    this.setData({
        eventViewHeight: eventRow ? 2*(29+34*eventRow+(eventRow - 1)*12) : 0,
        eventList: eventList,
        channels:channels,
        users:users,
        tags:tags
    })
  },
  timeintervalToStr: function(timeinterval) {
    if(!timeinterval) {
        return ""
    }
    let date = new Date(parseInt(timeinterval))
    return date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate()
  },
  eventTap(e) {
    let index = e.currentTarget.dataset.index
    let event = this.data.userData.events[index]

    let joperate = app.globalData.joperate 
    let je = {name:event.name, attributes:{}}
    joperate.onEvent(je) 
    
  },
  tapUserID(e){
    let tag = this.data.userData.tag[e.currentTarget.dataset.index]
    this.editInfo(0, "请输入" + tag.displayName, "", "请输入标识值一次，一次只能设置一个值", "", tag)
  },
  tapChannel(e) {
    let channel = this.data.channels[e.currentTarget.dataset.index]
    this.editInfo(1, "设置「" + channel.channelname + "」通道值", e.currentTarget.dataset.img, "请输入通道值", channel.channelvalue ? channel.channelvalue : "", channel)
  },
  tapUserProperty(e){
    let user = this.data.userData.user[e.currentTarget.dataset.index]
    var placeholder = "请输入属性值"
    var value = ""
    let editType = user.datatype
    if (editType == "datetime") {
        placeholder = "输入日期，格式yyyy-MM-dd"
    } else if (editType == "list") {
        placeholder = "请输入属性值,使用[,]分隔开"
    } else if (editType == "bool") {
        placeholder = "";
    }
    if (editType == "list") {
        if (user.value instanceof Array) {
            value = user.value.join(',')
        }
    } else if (editType == "datetime") {
        value = this.timeintervalToStr(user.value)
    } else {
        value = user.value
    }
    this.editInfo(2, "设置「" + user.displayName + "」属性值", "", placeholder, value, user)
  },
  editInfo(type, title, img, placeholder, text, param) {
    console.log(type + " " + JSON.stringify(param))
    var boolType = false
    if(type == 2 && param.datatype == "bool") {
        boolType = true
    }
    this.setData({
        popUI: {
            img: img,
            title: title,
            placeholder: placeholder,
            text: text,
            boolType: boolType
        },
        editBody: {
            type: type,
            param:param
        },
        displayPop: true
    })
    
  },
  editPopSubmit(e){
    this.commitData(e)
  },
  cancelPop() {
    //bool类型点击false
    if(this.data.popUI.boolType) {
        this.commitData(0)
    }
    this.setData({
        popUI: {
            boolType: false
        },
        displayPop: false
    })
  },

  commitData(e) {
    var value
    if(this.data.editBody.type == 2 && this.data.editBody.param.datatype == 'bool') {
        if(!e) {
            value = 0
        } else {
            value = 1
        }
    } else {
        value =  e.detail.value.editText
    }
    console.log(JSON.stringify(this.data.editBody) + " " + value) 

    let type = this.data.editBody.type 
    let param = this.data.editBody.param
    let jopreate = app.globalData.joperate
    let completion = (code, msg)=>{
        if(code) {
            wx.showToast({
              title: '设置失败',
            })
        } else {
            this.loadData()
        }
    }
    //用户标识
    if(type == 0) {
        let userIDs = {}
        userIDs[param.identityName] = value
        let user = {completion: completion, userIDs: userIDs}
        jopreate.identifyAccount(user)
    //用户渠道
    } else if (type == 1) {
        let channel = {
            completion: completion,
            channels: {}
        }
        let contact = {}
        contact[param["channelkey"]] = value
        channel.channels[param["channelid"]] = contact
        jopreate.setUserChannel(channel)
    //用户属性
    } else {
        let editType = param.datatype
        let type = param.type
        let user = {}
        user[param.key] = value
        if (editType == "number") {
            user[param.key] = parseFloat(value)
            if (type == 1) {
                jopreate.set(user, completion)
            } else {
                jopreate.increment(user, completion)
            }
        } else if (editType == "datetime") {
            let date = Date.parse(new Date(value))
            user[param.key] = date
            if (date) {
                jopreate.set(user, completion)
            }
        } else if (editType == "list") {
            let arr = value.split(',')
            user[param.key] = arr
            jopreate.set(user, completion)
        } else {
            jopreate.set(user, completion)
        }  
    }
    this.setData({
        popUI: {
            boolType: false
        },
        displayPop: false
    })
  },
  touchMove(){
    return false
  }
})