// index.js
// 获取应用实例
const app = getApp()

Page({
  data: {
    isValid: false,
    cuid: "",
    isDebugMode: false,
  },
  onLoad() {
    wx.setNavigationBarTitle({
      title: '极光运营增长Demo',
    })
    let joperate = app.globalData.joperate
    joperate.isValid((code,msg)=>{
        if(!code){
          this.setData({
            isValid: true,
            cuid: joperate.CUID(),
          })
        }
    })
  },
  getUserProfile(e) {
    // 推荐使用wx.getUserProfile获取用户信息，开发者每次通过该接口获取用户个人信息均需用户确认，开发者妥善保管用户快速填写的头像昵称，避免重复弹窗
    wx.getUserProfile({
      desc: '展示用户信息', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
      success: (res) => {
        console.log(res)
        this.setData({
          userInfo: res.userInfo,
          hasUserInfo: true
        })
      }
    })
  },
  getUserInfo(e) {
    // 不推荐使用getUserInfo获取用户信息，预计自2021年4月13日起，getUserInfo将不再弹出弹窗，并直接返回匿名的用户个人信息
    console.log(e)
    this.setData({
      userInfo: e.detail.userInfo,
      hasUserInfo: true
    })
  },
  copyCuid(){
    wx.setClipboardData({
      data: this.data.cuid,
    })
  },
  tapAdvance(){
    if (this.data.isDebugMode) {
      wx.navigateTo({
        url: '../advance/advance'
      })  
    } else {
      let that = this 
      wx.scanCode({
        success (res) { 
          console.log(res)
          let debug = app.globalData.joperate.openDebugMode(res.result)
          if (debug) {
            that.setData({
              isDebugMode:true
            })
          }
        }
      })      
    }
  },
  tapPreset(){
    wx.navigateTo({
      url: '../preset/preset'
    })
  },
  tapProject(){
    wx.navigateTo({
      url: '../project/project'
    })
  }
})
