# 微信小程序 SDK 集成指南
## 使用提示
本文是 JOperate 微信小程序 SDK 标准的集成指南文档。
匹配的 SDK 版本为：v2.0.0 及以后版本。

- 如果您想要快速地测试、请参考本文在几分钟内跑通 Demo。
- 极光推送文档网站上，有相关的所有指南、API、教程等全部的文档。包括本文档的更新版本，都会及时地发布到该网站上。

## 产品说明
利用事件模板统计 App 用户的行为事件并上报给极光服务器，极光提供加工过的数据通过 WebPortal 展示给开发者，让开发者更加了解自己的应用在用户手中的使用情况。
## 获取应用信息
完成数据源接入后，进入「数据源列表-详情」查看 AppKey 和 scheme。详情参考 [微信小程序平台接入](/public_service/dataCenter/data_source/wechat_applet)。

## 配置步骤
### 本地工程配置
解压 joperate-m-x.x.x-release.zip 压缩包，将 libs 下文件放置入项目中，目录自定义，例复制到工程下面。

- libs/joperate-m-x.x.x.js 
   - SDK operate 开发包
- libs/joperate-conf.js 
   - SDK operate 配置文件
- demo 
   - 是一个完整的小程序项目，通过这个演示了 JOperate SDK 的基本用法，可以用来做参考。

### 配置 joperate-conf.js
在 joperate-p-conf.js 配置 SDK 所需的集成信息并开启 debug 模式。示例如下：
```javascript
exports.appKey = ""; // 极光官网中创建应用后分配的 appkey，必填
exports.appid = ""; // 微信管理后台分配的 appid，必填
exports.channel = "default-channel"; // 渠道名称，默认值为:default-channel
exports.debugMode = true; // 设置是否开启 debug 模式。true 则会打印更多的日志信息。设置 false 则只会输出 w、e 级别的日志。
```

### 配置 npm

- 在小程序的 package.json 文件中配置需要的加密、压缩组件等。

```
  ...
  "dependencies": {
    "crypto-js": "^3.1.9-1",
    "pako": "^1.0.6",
    "wxmp-rsa": "^2.1.0"
  }
  ...
```

- 点击工具->构建 npm，完成 npm 配置。

### 配置 request 合法域名
需要在 [微信公众平台](https://mp.weixin.qq.com/) 开发设置中，添加 request 合法域名：`jiguang.cn, jpush.cn`。
### SDK 初始化

- 在 app.js 中导入 SDK 并调用初始化接口：

```
var _joperate = require('./joperate-m-2.0.0.js') 

App({
  onLaunch: function () {
	  ···
	   //在 app onLaunch 调用初始化
	  _joperate.init(this)
  }	,
  globalData: {
    joperate:_joperate
  }
  ···
})
```

> 在 app.js 的 onLaunch 调用初始化后可供每个页面使用，无需重复导入，需要时使用 app.globalData.joperate 调用 SDK 相关方法。

## 数据校验模式
若需要查看实时上报可以扫码进入数据校验模式，详情参考 [数据校验文档](/public_service/dataCenter/data_channel/check)。
## 更多 API
其他 API 的使用方法请参考接口文档：[MiniProgram SDK API](/public_service/client/wxapplet_sdk/sdk_api)
## 运行 demo
压缩包附带的 example 是一个 API 演示例子。你可以直接运行起来测试。运行可参考 [小程序官方文档](https://developers.weixin.qq.com/miniprogram/dev/framework/)。
## 技术支持
邮件联系：[support@jiguang.cn](mailto:support@jiguang.cn)
